//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A411850014C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A411850014C.cm

//## begin module%3A411850014C.cp preserve=no
//## end module%3A411850014C.cp

//## Module: XSparse%3A411850014C; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/XSparse.h

#ifndef XSPARSE_H
#define XSPARSE_H 1

//## begin module%3A411850014C.additionalIncludes preserve=no
//## end module%3A411850014C.additionalIncludes

//## begin module%3A411850014C.includes preserve=yes
//## end module%3A411850014C.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%3A411850014C.declarations preserve=no
//## end module%3A411850014C.declarations

//## begin module%3A411850014C.additionalDeclarations preserve=yes
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Utils/IosHolder.h>

#include <XSUtil/Utils/XSutility.h>
#include <deque>
#include <stack>
//## end module%3A411850014C.additionalDeclarations


//## begin XSparse%3A41180E03C8.preface preserve=yes
//## end XSparse%3A41180E03C8.preface

//## Class: XSparse%3A41180E03C8; Class Utility
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A53413F0068;std::istringstream { -> }
//## Uses: <unnamed>%3F00467A01FA;std::deque { -> }

class XSparse 
{
  //## begin XSparse%3A41180E03C8.initialDeclarations preserve=yes
  //## end XSparse%3A41180E03C8.initialDeclarations

  public:
    //## Class: SkipThis%3A65FABC0172
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class SkipThis : public YellowAlert  //## Inherits: <unnamed>%3A65FC6F016E
    {
      public:
        //## Constructors (specified)
          //## Operation: SkipThis%3A65FAF501E3
          SkipThis (const std::string& diag = "... skipped\n");

      protected:
      private:
      private: //## implementation
    };

    //## Class: AbortLoop%3A65FAD303B4
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class AbortLoop : public YellowAlert  //## Inherits: <unnamed>%3A65FC6B02E8
    {
      public:
        //## Constructors (specified)
          //## Operation: AbortLoop%3A65FB28008A
          AbortLoop (const std::string& diag = "terminated at user request\n");

      protected:
      private:
      private: //## implementation
    };

    //## Class: SyntaxError%3BAB49D6026A
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class SyntaxError : public YellowAlert  //## Inherits: <unnamed>%3BAB4A170318
    {
      public:
        //## Constructors (specified)
          //## Operation: SyntaxError%3BAB49EA0019
          SyntaxError (const std::string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: InputError%3BB4BFCF013B
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InputError : public YellowAlert  //## Inherits: <unnamed>%3BB4C0CD0072
    {
      public:
        //## Constructors (specified)
          //## Operation: InputError%3BB4C0A403DC
          InputError (const std::string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: InvalidRange%3BB4C006018C
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidRange : public YellowAlert  //## Inherits: <unnamed>%3BB4C09E0249
    {
      public:
        //## Constructors (generated)
          InvalidRange();

        //## Constructors (specified)
          //## Operation: InvalidRange%3BB4C0770208
          InvalidRange (const std::string& diag);

      protected:
      private:
      private: //## implementation
    };


    //## Other Operations (specified)
      //## Operation: findBatchString%3A411D8E002B
      //	Takes a set of Tcl_Objs and finds where the command ends
      //	and the subsequent input ("batch") begins.
      //
      //	Returns the command truncated by the subsequent
      //	batch strings, and a vector of strings representing the
      //	batch information.
      static void findBatchString (const string& cmdLine, string& command, std::deque<string>& batch);

      //## Operation: getRanges%3A411F47029C
      //	getRanges takes a string and outputs an integer array of
      //	indices in the range.
      //
      //	In XSPEC 11 this was done using tcl's Regexp machinery,
      //	but this won't be used here to keep tcl and xspec's
      //	innards separate.
      //
      //	The range should have the following forms:
      //
      //	a) * : all the indices that are relevant. For this it
      //	needs to be supplied the total number of relevant indices
      //
      //	b) n  : single number
      //
      //	c) n - m : a simple range
      //
      //	d) n1-m1,n2,n3-m3,...  a comma delimited set of ranges
      //
      //	e) n:*    from index n to the last index.
      //
      //	lastIndex = -1,  is used to denote the presence of wild
      //	cards in the range string.
      //
      //	Remember C++ uses zero-based indices!
      static IntegerArray getRanges (const string& rangeString, int lastIndex);

      //## Operation: oneRange%3A4120B503C2
      //	For an input string representing a "range", returns the
      //	beginning and ending numbers in that range.
      //
      //	endRange is returned as -1 if there is a wildcard
      //	character. If the range corresponds to just a '*',  begin
      //	Range is set to 1.
      //
      //	a string xsdelimiters represents the delimiters used in
      //	expressing the range, defaults to - and :
      static void oneRange (const string& inputRange, int& beginRange, int& endRange);

      //## Operation: returnDelimitedArgument%3A4121BC018A
      //	function for cutting a string at a delimiter. Returns a
      //	newly constructed string containing the next delimited
      //	argument and the input string, truncated to the remainder
      //	after the first delimited argument is split off.
      static string returnDelimitedArgument (string& inString, const string& xsdelim);

      //## Operation: getNextLine%3A4122A801F1
      //	Function for getting next line from file, with
      //	leading/trailing blanks/tabs removed.
      //
      //	Also, ignores lines that contain the '#' from that mark
      //	forward (this is a little more generous than tcl,
      //	functions like comment processing in make).
      static string getNextLine (std::ifstream& stream);

      //## Operation: parseInputModelString%3A412394032F
      //	function for parsing XSPEC model commands. It processes
      //	a string of the form
      //
      //	model <stringPar>:<intPar>  <commandString>
      //
      //	[The commandString, an XSPEC model string, is processed
      //	by the Expression class].
      static void parseInputModelString (const string& inputString, string& stringPar, size_t& intPar, string& commandString);

      //## Operation: integerPair%3A4124DC01F4
      //	Returns true if input is one of the following forms:
      //	<n> <n>: :<m> <n>:<m>, else returns false.
      //
      //	 If it returns true and the string contains only one
      //	integer and no colon, the second argument is set to -1.
      //
      //	If only one integer and there is a colon, the missing
      //	integer's argument is set to 1.
      //
      //	If it returns false, both arguments are set to -1.
      static bool integerPair (const string& arg, int& first, int& second);

      //## Operation: spaceString%3A4129A90388
      //	Routine from Xspec11 which spaces out a string to aid
      //	the parsing operation. Probably redundant, but at least
      //	requires an overhaul.
      static void spaceString (char** inputString);

      //## Operation: checkExponent%3A4129F402D3
      //	routine from Xspec11 for testing whether a string is an
      //	exponential number. Probably obsolete.
      static int checkExponent (char* inputString);

      //## Operation: getFileNameFromUser%3A65FB920226
      static void getFileNameFromUser (const string& oldName, string& newName, XSutility::fileType type);

      //## Operation: stringIntPair%3AA697B50178
      //	This is meant to handle input of type arg = "name
      //	String:n" or simply "n".  If it is the latter, word will
      //	be returned as an empty string. NOTE: in that case, this
      //	function actually returns "false" even though just "n"
      //	may be a valid input.  It is up to the calling functions
      //	to figure this out.  If n is not an int type, the
      //	"number" argument will be returned unchanged.
      static bool stringIntPair (const string& arg, string& word, size_t& number);

      //## Operation: stringRangePair%3C03F9FE0363
      static void stringRangePair (const string& arg, string& word, IntegerArray& range);

      //## Operation: catchSkips%3C0BCE5F00EA
      static void catchSkips (const string& input, bool silent = true);

      //## Operation: intStringPair%3CD69A500034
      //	Parse an int/string pair separated by the first
      //	appearance of the specified delimiter.  If delimiter is
      //	not found, number is set to s_NOTFOUND and word contains
      //	entire arg.  If delimiter is found and the left portion
      //	is not an int, this will throw a SyntaxError.
      static void intStringPair (const string& arg, size_t& number, string& word, char delim = ':');

      //## Operation: addToLibraryPath%3E5A5C6601C9
      static bool addToLibraryPath (const string& newDirectory, string& fullDirectory, int accessMode);

      //## Operation: expandDirectoryPath%3E5A5CD9001C
      static string expandDirectoryPath (const string& input);

      //## Operation: collectParams%3E5BDDBB027C
      static void collectParams (const std::vector<string>& args, IntegerArray& iParams, StringArray& xsParams);

      //## Operation: basicPrompt%3EC2540D00B7
      static void basicPrompt (const string& promptMsg, string& result, std::deque<string>* batchArgs = 0);

      //## Operation: promptResponseArf%3EC29072008F
      static void promptResponseArf (string& responseName, const string& defaultName, string& arfName, size_t& arfRow, const size_t specNum, bool demand = true, bool doArf = true, std::deque<string>* batchArgs = 0);

      //## Operation: changeExtension%3EC3B19B0322
      static void changeExtension (string& fileName, const string& extName, const bool duplicate = true);

      //## Operation: promptFilename%3EC3E60D00AF
      static string promptFilename (const string& defaultName = "", std::deque<string>* batchArgs = 0);

      //## Operation: collateByWhitespace%3EC50FB4009E
      static void collateByWhitespace (StringArray& outStrings, const string& inString);

      //## Operation: checkBrackets%3EF9F0E90042
      static void checkBrackets (StringArray& args, char bracketChar);

      //## Operation: IntToString%3F4240EB005A
      static string IntToString (size_t num);

      //## Operation: promptReal%3F427DDB021E
      static bool promptReal (const string& prompt, Real& real, std::deque<string>* batchArgs = 0);

      //## Operation: separate%3FBD14A80142
      static void separate (string& operand, const string& separators);

      //## Operation: expandRange%403BA96801EC
      static IntegerArray expandRange (const IntegerArray& range);

      //## Operation: trimWhiteSpace%412F545400F6
      static string trimWhiteSpace (const string& value);

      //## Operation: wildRange%419A56CC0350
      static RangePair wildRange (const string& inputRange, const RangePair& maxRange, RangePair& prevRange);

      //## Operation: getRanges%419B753A02E0
      static IntegerArray getRanges (const StringArray& inArgs, RangePair& prevRanges, const RangePair& rangeLimits);

      //## Operation: promptRealPair%41B613000326
      static bool promptRealPair (const string& prompt, std::pair<Real,Real>& vals, std::deque<string>* batchArgs);

      //## Operation: stringSegment%46F016510038
      //	Return a substring starting at the position given by p
      //	Start, with size up to (but not including) the first
      //	"\n", or the first n=length chars, whichever is
      //	shorter.  If stopping at n=length will break up a word
      //	or number, break instead at the last whitespace prior to
      //	it.  pStart will be reset to the position after the end
      //	of the returned segment (but not a "\n"), or npos if it
      //	has reached the end.  If pStart is initially out of
      //	range, return a blank string.
      static string stringSegment (const string& fullString, const size_t length, string::size_type* pStart);

      //## Operation: getCurlyBracketInt%48AC36D90157
      //	Looks for a specifier of the form "{n}" appended to a
      //	file name.  Returns the value n, and sets the "fileName"
      //	arg to the substring preceding the first '{'.  If no
      //	brackets, returns 0.  THROWS if anything other than a
      //	single non-negative integer is found between brackets,
      //	or if any non-WS follows the '}'.  Whitespace padding
      //	between the brackets is allowed.
      static int getCurlyBracketInt (const string& fullName, string& fileName);

      //## Operation: collateRanges%4A02FB5E00D7
      //	Designed for the untie/freeze/thaw group of commands and
      //	their resppar equivalents.  This will collate range
      //	strings by left-of-colon specifier, ie.
      //	   untie 3 5 a:1 ,2 b:1-2 a 4
      //	fills map with "":{"3","5"}
      //	                 "a":{"1","2","4"}
      //	                 "b":{"1-2"}
      //	Input:
      //	inArgs - The raw cmd line arg strings, 1-to-1 with Tcl's
      //	objv[], aside from the cmd name itself which is left out.
      //	prevName - Default name (if any) to be applied to empty
      //	left-of-colon args until superseded by a new name.
      //
      //	Output:
      //	prevName - The last specified left-of-colon name.
      //	rangeGroups - The collated map.
      //
      //	This does not actually check for valid range strings,
      //	but CAN THROW if colon is used improperly in string.
      static void collateRanges (const StringArray& inArgs, string& prevName, std::map<string,StringArray>& rangeGroups);

      //## Operation: checkExtendedSyntax%4A5CD01602F9
      //	Returns true if the filename includes extended syntax,
      //	currently defined as either ending in square brackets,
      //	or ending in "+<n>" where n is some integer.  Also fills
      //	in the location of either the '[' or the '+' if they
      //	exist, or npos if they don't.
      static bool checkExtendedSyntax (const string& filename, string::size_type& squareLoc, string::size_type& plusLoc);

      //## Operation: absToRelPath%4AAFE5F3009D
      //	Convert an absolute directory path to a relative one in
      //	relation to the referencePath position.  Both input
      //	paths must be Unix-style absolute path names, ie. first
      //	character must be '/'.  This will throw if otherwise.
      static string absToRelPath (const string& referencePath, const string& absPath);

      //## Operation: isBlank%4B97F58402B1
      //	Assumes charStr is 0 or points to a NULL-terminated char
      //	string.  Returns true if charStr is 0 or string contains
      //	no non-whitespace chars.
      static bool isBlank (const char* charStr);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: XCM_LEN%3A41315F02E2
      static const size_t CommandLength ();

      //## Attribute: NONE%3A537A9B0295
      static const string& NONE ();

      //## Attribute: SKIP%3AB91B5D0207
      static const string& SKIP ();

      //## Attribute: rangeIsReal%3BDD7BBF009B
      static const bool rangeIsReal ();
      static void rangeIsReal (bool value);

      //## Attribute: NOTFOUND%3C067E330346
      static const string::size_type& NOTFOUND ();

      //## Attribute: executingScript%3E8D96CC00E5
      static const bool executingScript ();
      static void executingScript (bool value);

      //## Attribute: USE_DEFAULT%3F439FA001BA
      static const string& USE_DEFAULT ();

  public:
    // Additional Public Declarations
      //## begin XSparse%3A41180E03C8.public preserve=yes
      template <typename T>
      static void
      getArg (std::istream& s, T& value,  const T& defaultValue, const string& prompt);

      template <typename T>
      static string ArrayToRange (const T& array);
      //## end XSparse%3A41180E03C8.public
  protected:
    // Additional Protected Declarations
      //## begin XSparse%3A41180E03C8.protected preserve=yes
      //## end XSparse%3A41180E03C8.protected

  private:

    //## Other Operations (specified)
      //## Operation: hasRange%3A53997300DA
      //	returns true if a string has a range string, and
      //	leaves first '{' and '}'  index numbers in begin and end
      //	arguments. end is return as strg.length() if the close
      //	has been inadvertently left off.
      static bool hasRange (const string& strg, size_t& beginRng, size_t& endRng);

      //## Operation: validateRangeSpecifier%419B7380025D
      static size_t validateRangeSpecifier (const string& rangeString);

      //## Operation: pathToStack%4AAFE49400A4
      //	Utility function used by absToRelPath
      static void pathToStack (const string& referencePath, std::stack<string>& pathStack);

    // Additional Private Declarations
      //## begin XSparse%3A41180E03C8.private preserve=yes
      //## end XSparse%3A41180E03C8.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: STRINGNULLS%3A412DB1027C
      //## begin XSparse::STRINGNULLS%3A412DB1027C.attr preserve=no  private: static string {VC} " \t"
      static const string STRINGNULLS;
      //## end XSparse::STRINGNULLS%3A412DB1027C.attr

      //## Attribute: INPUT_DELIMITER%3A41307703CE
      //## begin XSparse::INPUT_DELIMITER%3A41307703CE.attr preserve=no  private: static string {VC} "&"
      static const string INPUT_DELIMITER;
      //## end XSparse::INPUT_DELIMITER%3A41307703CE.attr

      //## begin XSparse::XCM_LEN%3A41315F02E2.attr preserve=no  public: static size_t {VC} 256
      static const size_t XCM_LEN;
      //## end XSparse::XCM_LEN%3A41315F02E2.attr

      //## begin XSparse::NONE%3A537A9B0295.attr preserve=no  public: static string {UC} "none"
      static const string s_NONE;
      //## end XSparse::NONE%3A537A9B0295.attr

      //## begin XSparse::SKIP%3AB91B5D0207.attr preserve=no  public: static string {VC} "/*"
      static const string s_SKIP;
      //## end XSparse::SKIP%3AB91B5D0207.attr

      //## begin XSparse::rangeIsReal%3BDD7BBF009B.attr preserve=no  public: static bool {U} false
      static bool s_rangeIsReal;
      //## end XSparse::rangeIsReal%3BDD7BBF009B.attr

      //## begin XSparse::NOTFOUND%3C067E330346.attr preserve=no  public: static string::size_type {UC} string::npos
      static const string::size_type s_NOTFOUND;
      //## end XSparse::NOTFOUND%3C067E330346.attr

      //## Attribute: augmentedLibraryPath%3E5A5D5C0395
      //## begin XSparse::augmentedLibraryPath%3E5A5D5C0395.attr preserve=no  private: static char* {U} 0
      static char* s_augmentedLibraryPath;
      //## end XSparse::augmentedLibraryPath%3E5A5D5C0395.attr

      //## begin XSparse::executingScript%3E8D96CC00E5.attr preserve=no  public: static bool {U} false
      static bool s_executingScript;
      //## end XSparse::executingScript%3E8D96CC00E5.attr

      //## begin XSparse::USE_DEFAULT%3F439FA001BA.attr preserve=no  public: static string {VC} "/"
      static const string s_USE_DEFAULT;
      //## end XSparse::USE_DEFAULT%3F439FA001BA.attr

    // Additional Implementation Declarations
      //## begin XSparse%3A41180E03C8.implementation preserve=yes
      //## end XSparse%3A41180E03C8.implementation

};

//## begin XSparse%3A41180E03C8.postscript preserve=yes
template <typename T>
void XSparse::getArg (std::istream& s, T& value,  const T& defaultValue, const string& prompt )
{
        string input("");
        while (1) 
        {
                *IosHolder::errHolder() << "re-enter ( \"/*\" to abort or \"/\" to use default value )\n"; 
                XSstream* xscout = dynamic_cast<XSstream*>(IosHolder::outHolder());
                if (xscout)
                {
                   XSstream::setPrompter(s,prompt);
                }
                else
                {  
                   *IosHolder::outHolder() << prompt;
                }
                s >> input;
                std::istringstream t(input);
                t.exceptions(std::ios_base::failbit);
                try
                {
                        if ( t.str() == s_SKIP) throw AbortLoop();
                        if ( t.str() == "/")
                        {
                                value = defaultValue;
                                break;
                        }
                        else
                        {
                                t >> value;
                                break; 
                        }
                }
                catch ( std::exception& )
                {
                        continue;
                }
        }
        
}

template <typename T>
string XSparse::ArrayToRange (const T& array)
{
    size_t count = array.size(), rangeStart = 0;

    int diff = 0;

    std::string range = (count > 0 ? IntToString(array[0]) : std::string(""));

    for(size_t i = 1; i <= count; ++i) {
	if(i == count || 
	   (diff = array[i] - array[i - 1]) >= 2 || diff < 0)
	{
	    if(rangeStart != i - 1)
		range += '-' + IntToString(array[i - 1]);

	    rangeStart = i;
	    if(i != count) 
		range += ',' + IntToString(array[i]);
	}
    }
    return range;
}
//## end XSparse%3A41180E03C8.postscript

// Class XSparse::SkipThis 

// Class XSparse::AbortLoop 

// Class XSparse::SyntaxError 

// Class XSparse::InputError 

// Class XSparse::InvalidRange 

// Class Utility XSparse 

//## Get and Set Operations for Class Attributes (inline)

inline const size_t XSparse::CommandLength ()
{
  //## begin XSparse::CommandLength%3A41315F02E2.get preserve=no
  return XCM_LEN;
  //## end XSparse::CommandLength%3A41315F02E2.get
}

inline const string& XSparse::NONE ()
{
  //## begin XSparse::NONE%3A537A9B0295.get preserve=no
  return s_NONE;
  //## end XSparse::NONE%3A537A9B0295.get
}

inline const string& XSparse::SKIP ()
{
  //## begin XSparse::SKIP%3AB91B5D0207.get preserve=no
  return s_SKIP;
  //## end XSparse::SKIP%3AB91B5D0207.get
}

inline const bool XSparse::rangeIsReal ()
{
  //## begin XSparse::rangeIsReal%3BDD7BBF009B.get preserve=no
  return s_rangeIsReal;
  //## end XSparse::rangeIsReal%3BDD7BBF009B.get
}

inline void XSparse::rangeIsReal (bool value)
{
  //## begin XSparse::rangeIsReal%3BDD7BBF009B.set preserve=no
  s_rangeIsReal = value;
  //## end XSparse::rangeIsReal%3BDD7BBF009B.set
}

inline const string::size_type& XSparse::NOTFOUND ()
{
  //## begin XSparse::NOTFOUND%3C067E330346.get preserve=no
  return s_NOTFOUND;
  //## end XSparse::NOTFOUND%3C067E330346.get
}

inline const bool XSparse::executingScript ()
{
  //## begin XSparse::executingScript%3E8D96CC00E5.get preserve=no
  return s_executingScript;
  //## end XSparse::executingScript%3E8D96CC00E5.get
}

inline void XSparse::executingScript (bool value)
{
  //## begin XSparse::executingScript%3E8D96CC00E5.set preserve=no
  s_executingScript = value;
  //## end XSparse::executingScript%3E8D96CC00E5.set
}

inline const string& XSparse::USE_DEFAULT ()
{
  //## begin XSparse::USE_DEFAULT%3F439FA001BA.get preserve=no
  return s_USE_DEFAULT;
  //## end XSparse::USE_DEFAULT%3F439FA001BA.get
}

//## begin module%3A411850014C.epilog preserve=yes
//## end module%3A411850014C.epilog


#endif
